/* 
 * Copyright (c) 2000 Carnegie Mellon University.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The name "Carnegie Mellon University" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For permission or any other legal
 *    details, please contact  
 *      Office of Technology Transfer
 *      Carnegie Mellon University
 *      5000 Forbes Avenue
 *      Pittsburgh, PA  15213-3890
 *      (412) 268-4387, fax: (412) 268-7395
 *      tech-transfer@andrew.cmu.edu
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Computing Services
 *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
 *
 * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
 * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef WINDOWS_H
#define WINDOWS_H

void WIN_DisplayPosition(WINLIST *awp,long offset, long size,int use_real_size);

int WIN_FrontWindow(WINLIST *alink);

void WIN_CloseFrontWindow(void);

void WIN_Write(WINLIST *alink,char *text,int row, int col, int len, int attr);

void WIN_HomeCursor(void);

void WIN_BringToFront(WINLIST *alink);

void WIN_BehindFrontWindow(WINLIST *awp);

void WIN_Update(WINLIST *alink);

void WIN_HideWindow(WINLIST *aw);

void WIN_Dispose(WINLIST *alink);

void WIN_RedrawScreen(void);

void WIN_SetTitle(WINLIST *awp,char *title);

void WIN_WindowChangedSize(WINFO *win);

void WIN_Move(WINLIST *awp);

void WIN_Zoom(WINLIST *awp);

void WIN_Resize(WINLIST *awp);

int WIN_DoKey(int key);

void WIN_DoSetupMenus(void);

void WIN_init(void (*mproc)());

void WIN_HLSelection(int on_off);

void WIN_RefreshRegion(int r,int c,int h,int w);

void WIN_HomeCursor(void);

void WIN_DoSetupMenus(void);

void WIN_CalcVisRegion(void);

void WIN_LockCursor(int lock);

void WIN_dlink(WINLIST *alink,int free_link);

void WIN_Box(WINLIST *awin,int rows, int cols, int ypos, int xpos, int attr);

int WIN_CheckBounds(int r, int c, int h, int w);

void WIN_RefreshUnion(int r,int c,int h,int w,WINFO *win);

int WIN_MoveOrResize(WINFO *win,int move_or_resize);

void WIN_OverlayMap(WINFO *win);

int WIN_link(WINFO *awin);

int WIN_GetNewId(void);

void WIN_LinktoTail(WINLIST *alink);

void WIN_AdjustSizes(void);

void WIN_SetMode(int mode);

void WIN_Reinitialize(void);

#endif /* WINDOWS_H */
